{-# OPTIONS -fglasgow-exts #-}
{-# OPTIONS -fallow-undecidable-instances #-}
{-# OPTIONS -fallow-overlapping-instances #-}
{-# OPTIONS -fth #-}
{-# OPTIONS -fgenerics #-}
module TestBase where

-- this file tests functionality in NominalBase

import NominalBase
import Data.RepLib
import Debug.Trace

data Abs a b = Abs a b deriving Show
$(derive [''Abs])

instance (Eq a, Nominal a b, Rep a, Rep b) => Nominal a (Abs a b) where
    swap                       = swapR1 rep1   
    fresh a (Abs x y)          = a `elem` [x] || fresh a y
    aeq (p :: Proxy a) (Abs x y) (Abs x' y')  = (aeq p x x') && (aeq p y y')
				 || case equiv x x' 
					 of Just pi ->  all (\a -> fresh a y') (bound x)
                                                        && aeq p y (perm pi y')
					    Nothing ->  False
    perm                       = permR1 rep1   

bound :: Eq a => a -> [a]
bound a = [a]

equiv :: Eq a => a -> a -> Maybe [(a, a)]
equiv a b = Just [(a,b)]


data Lam = Var Name
	 | App Lam Lam
	 | Lam (Abs Name Lam)  deriving Show
$(derive [''Lam])


t1 = Var (Name "x" Nothing)
t2 = Lam (Abs (Name "x" Nothing) (Var (Name "y" Nothing)))
t3 = Lam (Abs (Name "x" Nothing) (Var (Name "x" Nothing)))
t4 = Lam (Abs (Name "y" Nothing) (Var (Name "x" Nothing)))
t5 = Lam $ Abs (Name "x" Nothing) (Lam (Abs (Name "y" Nothing) (Var (Name "x" Nothing))))
t6 = Lam $ Abs (Name "y" Nothing) (Lam (Abs (Name "x" Nothing) (Var (Name "y" Nothing))))

p1 = (Name "x" Nothing, Name "y" Nothing)
p2 = [(Name "x" Nothing, Name "y" Nothing)]

x = Name "x" Nothing
y = Name "y" Nothing

main = do print $ swap p1 t1
	  print $ swap p1 t2
	  print $ perm p2 t1
	  print $ perm p2 t2
	  print $ perm p2 t3
	  print $ fresh x t1
	  print $ fresh y t1
	  print $ fresh x t2
	  print $ fresh y t2
	  print $ fresh x t3
	  print $ aeqN t2 t3
	  print $ aeqN t2 t4
	  print $ aeqN t5 t6
